class iaas::profile::neutron::server (
  $public_interface = hiera('iaas::public_interface', undef),
  $admin_interface = hiera('iaas::admin_interface', undef),

  $neutron_password = hiera('iaas::profile::neutron::password', undef),
  $nova_password = hiera('iaas::profile::nova::controller::password', undef),

  $region = hiera('iaas::region', undef),
#VIP1
  $endpoint_main = hiera('iaas::main_address', undef),
#VIP2
  $endpoint_admin = hiera('iaas::admin_address', undef),
) {
  include iaas::resources::connectors

##Leave commented if DB is not controller
#  iaas::resources::database { 'neutron': }

  include iaas::profile::neutron::common

  if $endpoint_admin == '' {
    $real_endpoint_admin = $endpoint_main
  }else{
    $real_endpoint_admin = $endpoint_admin
  }

  class { '::neutron::server':
    auth_host => $real_endpoint_admin,
    auth_uri => "http://${endpoint_main}:5000/v2.0",
##identity_uri set to be added in next OS release
#    identity_uri => "http://${real_endpoint_admin}:35357",
    auth_password => $neutron_password,
    database_connection => $iaas::resources::connectors::neutron,
    enabled => true,
    sync_db => true,
    mysql_module => '2.3',
    database_idle_timeout => 3600,
    l3_ha => false,
  }

  neutron_config { 
    'DEFAULT/allow_automatic_l3agent_failover' : value => "True";
    'keystone_authtoken/identity_uri' :value => "http://${real_endpoint_admin}:35357";
  }

  class { '::neutron::keystone::auth':
    password => $neutron_password,
    public_address => $endpoint_main,
    admin_address => $real_endpoint_admin,
    internal_address => $real_endpoint_admin,
    region => $region,
  }

  class { '::neutron::server::notifications':
    nova_url => "http://${real_endpoint_admin}:8774/v2",
    nova_admin_auth_url => "http://${real_endpoint_admin}:35357/v2.0",
    nova_admin_password => $nova_password,
    nova_region_name => $region,
    nova_admin_tenant_name => "services",
 }

}
